/*proc to calculate forecast and conditional
forecast standard deviation from posterior of two regime tar model with difference delays

*/


proc for2tard(b1,b2,r1,d,s1,s2,_x,k,n,nn);

/*********************************************
b1,b2, are the regime ar coefficients, with intercept in first row,
eg b1 is p+1 X k, K represents number of draws from the posterior, the
rows are the coefficients for individual lags
 b1 is the lower regime, b2 is the upper regime
r1,d are scalars and drawn in the main program, r1assumed
s1,s2 are all 1 X K and are the regime standard deviations,
_x is the 1Xp set of initial conditions
n is number of monte carlo draws for the forecast,
nn is the horizon for the forecast function
****************************************************************/

local y,x,u,i,j,p,e1,e2,e3,gi;

p=rows(b1)-1;

/*find initial forecast and set up the matrices*/

e1=((_x[d,.]-_x[d+1,.]).<=r1);
e2=(1-(e1));



u=rndn(n,1);

x=reshape(_x[1,.],n,k);
j=2;do until j>p+1;
x=x~reshape(_x[j,.],n,k);
j=j+1;endo;

y=(b1[1,.].*e1+b2[1,.].*e2)+(s1*e1+s2*e2).*u;

j=1; do until j>p;

y=y+x[.,(j-1)*k+1:j*k].*(e1.*b1[j+1,.]+e2.*b2[j+1,.]);
j=j+1;endo;
if p>1;
x[.,k+1:k*(p+1)]=x[.,1:(p)*k];
endif;

x[.,1:k]=y;





gi=zeros(nn,2);
gi[1,.]=meanc(meanc(y))~stdc(meanc(y));
for i (1,nn-1,1);





u=rndn(n,1);
e1=((x[.,(d-1)*k+1:d*k]-x[.,d*k+1:(d+1)*k]).<=r1);
e2=(1-(e1));

y=(b1[1,.].*e1+b2[1,.].*e2)+(s1.*e1+s2.*e2).*u;
for j (1,p,1);

y=y+x[.,(j-1)*k+1:j*k].*(e1.*b1[j+1,.]+e2.*b2[j+1,.]);
endfor;
if p>1;
x[.,k+1:k*(p+1)]=x[.,1:(p)*k];
endif;
x[.,1:k]=y;


gi[i+1,.]=meanc(meanc(y))~stdc(meanc(y));

endfor;
retp(gi);
endp;
